/* xloadimage.h:
 *
 * jim frost 06.21.89
 *
 * Copyright 1989 Jim Frost.  See included file "copyright.h" for complete
 * copyright information.
 */

#include "copyright.h"
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "image.h"
#include "options.h"

/* This struct holds the X-client side bits for a rendered image.
 */

typedef struct {
  Display  *disp;       /* destination display */
  int       scrn;       /* destination screen */
  int       depth;      /* depth of drawable we want/have */
  Drawable  drawable;   /* drawable to send image to */
  Pixel     foreground; /* foreground and background pixels for mono images */
  Pixel     background;
  Colormap  cmap;       /* colormap used for image */
  GC        gc;         /* cached gc for sending image */
  XImage   *ximage;     /* ximage structure */
} XImageInfo;

#ifndef MAXIMAGES
#define MAXIMAGES BUFSIZ /* max # of images we'll try to load at once */
#endif

/* function declarations
 */

void supportedImageTypes(); /* imagetypes.c */
void dumpImage(Image *, char *, char *, int);

char *tail(char *); /* misc.c */
void memoryExhausted();
void internalError(int);
void version();
void usage();
void goodImage(Image *, char *); /* new.c */
int errorHandler(Display *, XErrorEvent *); /* misc.c */

void showConfiguration(); /* config.c */
void listImages();

char *expandPath(char *); /* path.c */
int findImage(char *, char *); /* config.c */
void listImages();
void loadPathsAndExts();
void showPath();

void imageOnRoot(Display *, int, Image *, OptionSet *, unsigned int); /* root.c */

void        sendXImage(XImageInfo *, int, int, int, int, unsigned int, unsigned int); /* send.c */
XImageInfo *imageToXImage(Display *, int, Visual *, unsigned int, Image *, unsigned int, unsigned int, unsigned int);
Pixmap      ximageToPixmap(Display *, Window, XImageInfo *);
void        freeXImage(Image *, XImageInfo *);

Visual *getBestVisual(); /* visual.c */

int   visualClassFromName(char *); /* window.c */
char *nameOfVisualClass(int);
void cleanUpWindow(Display *);
char imageInWindow(Display *, int, Image *, OptionSet *, OptionSet *, int, char **, unsigned int);
